c      THE NAME OF THE PROGRAM:2dan.f
c      2D STEADY CONDUCTION WITH HEAT GENERATION IN A SQUARE SLAB
c      PROGRAM FOR OBTAINING EXACT SOLUTION (SEE EQ.(10.59)) 
c      SOLUTION ON A (4x4) GRID,THAT IS,FOR (5x5)GRID POINTS.  
c      THE OUTPUT CAN BE SEEN BY VIEWING 'temp' FILE.
c      THE OUTPUT SHOWS THE TEMPERATURE DISTRIBUTION IN THE UPPER
c      RIGHTHAND QUARTER OF THE ORIGINAL PHYSICAL DOMAIN.
       DIMENSION QE(99,99)
       open(unit=79,file='temp')
       N=5
       PI=3.1415
       DX=1.0/(FLOAT(N)-1)
       DO 50 I=1,N
       X =DX*(FLOAT(I)-1)
       DO 60 J=1,N
       Y =DX*(FLOAT(J)-1)
       P1=(1.-X*X)/2.
       PP4=P1
       K=-1.0
  65   K=K+1
       YY=(2.*FLOAT(K)+1.)*PI/2.
       PO2=(-1.0)**FLOAT(K)
       P2=PO2*COSH(YY*Y)*COS(YY*X)
       PO3=YY**3.
       P3=PO3*COSH(YY)
       P4=2*P2/P3
       PP4=PP4-P4
       ER=ABS(P4)/PP4
       IF (ER .GE. 0.001) THEN
       GOTO 65
       END IF
       K=MAX(K1,K)
       K1=K
       QE(I,J)=PP4
   60  CONTINUE
   50  CONTINUE
       do 47 i=1,5
       j=5
       QE(i,j)=0
   47  CONTINUE
       WRITE(79,19)
 19    FORMAT(2x,'TEMPERATURE DISTRIBUTION IN THE UPPER RIGHT QUARTER'/)
       WRITE(79,9)
  9    FORMAT(2x,'THE EXACT SOLUTION'/)
       DO 39 j=5,1,-1
   39    WRITE(79,7)(QE(I,J),I=1,5)
   7   format(2x,5f6.3)
       STOP
       END 	 
