C     THE NAME OF THE PROGRAM IS: 2dtranscond.f                                                   
C     EXAMPLE 10.4
C     TRANSIENT 2D HEAT CONDUCTION WITH RADIATION BOUNDARY CONDITION
C     THE INPUT DATA ARE TO BE ENTERED IN AN INTERACTIVE MANNER.

      DIMENSION T(150,150),T1(150,150)
      OPEN (UNIT=2,FILE='P.TXT')
      WRITE(*,*)  '      '    
      WRITE(*,*)  'PROGRAM TO CALCULATE TEMPERATURE DISTRIBUTION IN AN '
      WRITE(*,*)  ' INFINITELY LONG BAR HAVING SQUARE CROSS SECTION '
      WRITE(*,*)  '      '
      WRITE(*,*)  '       ENTER THE VALUE OF N              '
      WRITE(*,*)  '  (N+1,N+1 IS THE NO. OF GRID POINTS)    '
      READ *, N
      WRITE(*,*) 'ENTER THE VALUE OF B (DIMENSIONLESS PARAMETER) '
      READ *, B
      WRITE(*,*) 'ENTER THE VALUE OF Y (DIMENSIONLESS PARAMETER) '
      READ *, Y
      WRITE(*,*) 'ENTER THE VALUE OF DT (DIMENSIONLESS TIME STEP) '
      READ *, DT

      DO 5 I=1,N+1
      DO 5 J=1,N+1
5     T(I,J)=0.0
      DX=1.0/N

      K=0
100   K=K+1

C     CHECKING OF STABILITY LIMIT FOR INTERIOR AND BOUNDARY POINTS

      DT1=0.25*((DX)**2)
      A=(2.0*DX)/(B*(1.0-Y))
      Y2=Y**2
      Y3=Y**3
      Y4=Y**4 
      Z=((T(I,J))**3)*(1.0-4.0*Y+2.0*Y2+4.0*Y3+Y4)+((T(I,J))**2)*(4.0*Y-
     .8.0*Y2+4.0*Y4)+(T(I,J))*(6.0*Y2-12.0*Y3+2.0*Y4)+(4.0*Y3-4.0*Y4)
      DT2=((DX)**2)/(4.0+A*Z)
      DT3=((DX)**2)/(4.0+2.0*A*Z)
      DTM=DT1
      IF(DT2.LT.DTM) DTM=DT2
      IF(DT3.LT.DTM) DTM=DT3
      R=DT/(DX)**2
      

C     CALCULATING THE TEMPERATURE AT INTERIOR GRID POINTS

      DO 10 I=2,N
      DO 20 J=2,N
      T1(I,J)=(1.0-4.0*R)*(T(I,J))+R*(T(I+1,J)+T(I-1,J)+T(I,J+1)+T(I,J-1
     .))
20    CONTINUE
10    CONTINUE

C     CALCULATING THE TEMPERATURE AT BOTTOM BOUNDARY GRID POINTS

      DO 30 I=1,N+1
      J=1
      IF (I.EQ.1) THEN
      T1(I,J)=(1.0-4.0*R)*(T(I,J))+2.0*R*(T(I+1,J)+T(I,J+1))
      ELSE
      IF(I.EQ.N+1) THEN
      T1(I,J)=(1.0-4.0*R)*(T(I,J))+2.0*R*(T(I,J+1))+2.0*R*(T(I-1,J))+A*R
     .*(1.0-(T(I,J)+Y*(1.0-T(I,J)))**4)
      ELSE
      T1(I,J)=(1.0-4.0*R)*(T(I,J))+2.0*R*(T(I,J+1))+R*(T(I-1,J)+T(I+1,J)
     .)
      ENDIF
      ENDIF
30    CONTINUE

C     CALCULATING THE TEMPERATURE AT LEFT BOUNDARY GRID POINTS

      DO 40 J=2,N+1
      I=1
      IF (J.EQ.N+1) THEN
      T1(I,J)=(1.0-4.0*R)*(T(I,J))+2.0*R*(T(I+1,J))+2.0*R*(T(I,J-1))+A*R
     .*(1.0-(T(I,J)+Y*(1.0-T(I,J)))**4)
      ELSE
      T1(I,J)=(1.0-4.0*R)*(T(I,J))+2.0*R*(T(I+1,J))+R*(T(I,J-1)+T(I,J+1)
     .)
      ENDIF
40    CONTINUE

C     CALCULATING THE TEMPERATURE AT RIGHT BOUNDARY GRID POINTS

      DO 50 J=2,N+1
      I=N+1
      IF(J.EQ.N+1) THEN
      T1(I,J)=(1.0-4.0*R)*(T(I,J))+2.0*R*(T(I-1,J))+2.0*R*(T(I,J-1))+2.0
     .*A*R*(1.0-(T(I,J)+Y*(1.0-T(I,J)))**4)
      ELSE
      T1(I,J)=(1.0-4.0*R)*(T(I,J))+2.0*R*(T(I-1,J))+R*(T(I,J-1)+T(I,J+1)
     .)+A*R*(1.0-(T(I,J)+Y*(1.0-T(I,J)))**4)
      ENDIF
50    CONTINUE

C     CALCULATING THE TEMPERATURE AT TOP BOUNDARY GRID POINTS

      DO 60 I=2,N
      J=N+1
      T1(I,J)=(1.0-4.0*R)*(T(I,J))+2.0*R*(T(I,J-1))+R*(T(I-1,J)+T(I+1,J)
     .)+A*R*(1.0-(T(I,J)+Y*(1.0-T(I,J)))**4)
60    CONTINUE
      
      E=K*DT
      WRITE(2,65) E
65    FORMAT(1X,' TEMPERATURE VALUES  AT DIMENSIONLESS TIME =',F10.6)
      DO 70 J=N+1,1,-1
      WRITE(2,75) (T1(I,J),I=1,N+1)
75    FORMAT(1X,21F8.4)
70    CONTINUE
      DO 80 I=1,N+1
      DO 90 J=1,N+1
      T(I,J)=T1(I,J)
90    CONTINUE
80    CONTINUE
            
      IF(T(1,1).LE.0.5) GOTO 100
      IF(DT.GT.DTM) THEN 
      PRINT *, '  DT VALUE DOES NOT SATISFY STABILITY CRITERION ' 
      PRINT *, '           FOR CHOSEN GRID SIZE   '
      ELSE
      PRINT *, 'THE TEMPERATURE VALUE  IS STORED IN THE FILE P.TXT '
      ENDIF

      CLOSE(UNIT=2) 
      STOP
      END

