c       THE NAME OF THE PROGRAM:gspp.f
c       2D STEADY CONDUCTION WITH HEAT GENERATION IN A SQUARE SLAB
c       FOR PROBLEM FORMULATION SEE SECTION 10.3.2 OF THE BOOK.
c       SOLUTION ON A (4x4) GRID,THAT IS,FOR (5x5)GRID POINTS.
c       POINT BY POINT G-S METHOD WITH SUCCESSIVE OVER-RELAXATION(SOR)
c       SEE SECTION 10.3.1.1 AND EXAMPLE 10.1 OF THE BOOK FOR DETAILS OF THE METHOD.
c       THE OVER-RELAXATION FACTOR IS 'Alfa'IN THE PROGRAM.
c       PROGRAM FOR SOLUTION OF EQ.(10.58)
c       THE OUTPUT CAN BE SEEN BY VIEWING 'temp1'FILE.
c       THE OUTPUT FILE SHOWS TEMPERATURE DISTRIBUTION IN THE UPPER
c       RIGHTHAND QUARTER OF THE ORIGINAL PHYSICAL DOMAIN.
	PARAMETER (N=5,M=5)
	DIMENSION T(N,N),T1(N,N)
	DIMENSION TA(N,N)
	Open(unit=10,File='temp1')
	Do j=1,N
	TA(N,j)=0.
	TA(j,N)=0.
	Enddo
	kj=N
	Do i=1,N
	TA(i,kj)=0.
	Enddo
	X=1./(Float(N-1))
	Alfa=1
40	Do i=1,N
	Do j=1,N
	T(i,j)=0.
	T1(i,j)=0.
	TA(i,j)=0.
	Enddo
	Enddo
	K=0
 50	K=K+1
	Do i=N-1,2,-1
	Do j=N-1,2,-1
	T(i,j)=(X**2+TA(i+1,j)+TA(i,j+1)
     1  	+TA(i,j-1)+TA(i-1,j))/4.
	TA(i,j)=T1(i,j)+Alfa*(T(i,j)-T1(i,j))
c	Write (*,*) TA(N,N) 
	Enddo   
	Enddo
	Do j=N-1,2,-1
	T(1,j)=(X**2+TA(1,j+1)+TA(1,j-1)+2*TA(2,j))/4.
	TA(1,j)=T1(1,j)+Alfa*(T(1,j)-T1(1,j))
	Enddo
	Do i=N-1,2,-1
	T(i,1)=(X**2+TA(i+1,1)+TA(i-1,1)+2*TA(i,2))/4.
	TA(i,1)=T1(i,1)+Alfa*(T(i,1)-T1(i,1))
	Enddo
	T(1,1)=(X**2+2*TA(1,2)+2*TA(2,1))/4.
	TA(1,1)=T1(1,1)+Alfa*(T(1,1)-T1(1,1))
	Do i=1,N-1
	Do j=1,N-1
	Comp=ABS(TA(i,j)-T1(i,j))
	IF (Comp.LE. 0.001) goto 101 
	goto 100

101	Enddo	
	Enddo
	Write(10,*)'TEMPERATURE DISTRIBUTION IN THE UPPER RIGHT QUARTER'
	Write(10,*)'GAUSS-SEIDEL METHOD WITH SOR'
	Write(10,*)'ALPHA=',Alfa,' AND ITERATIONS=',K
	Write(10,*)'--------------------------------'
	Do i=N,1,-1
	Write (10,4) i,(TA(i,j),j=1,N) 
	Enddo
	Write (10,5) (i,i=1,N) 

 4     FORMAT (i2,2X,5F15.3) 
 5     FORMAT (7X,5(I10,5X)) 
	IF (ALFA.LT.1.9) goto 15 
	goto 11 
15	Alfa=Alfa+0.1
	goto 40
100	Do i=1,N
	Do j=1,N
	T1(i,j)=TA(i,j)
	Enddo
	Enddo
	goto 50
11	STOP
	END
