c THE NAME OF THE PROGRAM:tdma.f
c SUBROUTINE FOR SOLVING A SYSTEM OF LINEAR
c SIMULTANEOUS ALGEBRAIC EQUATIONS HAVING
c A TRIDIAGONAL COEFFICIENT MATRIX.
c THE EQUATIONS ARE NUMBERED FROM I THROUGH N,
c AND THEIR SUB-DIAGONAL,DIAGONAL AND SUPER-DIAGONAL
c ELEMENTS ARE STORED IN THE ARRAYS A,B,AND C.THE
c RIGHT-HAND COLUMN VECTOR ELEMENTS ARE STORED
c IN THE ARRAY D.THE COMPUTED SOLUTION VECTOR X(I)....X(N)
c IS STORED IN THE ARRAY X.

	SUBROUTINE TDMA(I,N,A,B,C,D,X)
	DIMENSION A(1),B(1),C(1),D(1),X(1),BETA(101),GAMMA(101)
c ****** COMPUTE INTERMEDIATE ARRAYS BETA AND GAMMA ******
	BETA(I)=B(I)
	GAMMA(I)=D(I)/BETA(I)
	I1=I+1
	DO 1 J=I1,N
	BETA(J)=B(J)-A(J)*C(J-1)/BETA(J-1)
   1    GAMMA(J)=(D(J)-A(J)*GAMMA(J-1))/BETA(J)
c ****** COMPUTE THE SOLUTION VECTOR X ******
	X(N)=GAMMA(N)
	N1=N-I
	DO 2 K=1,N1
	J=N-K
   2    X(J)=GAMMA(J)-C(J)*X(J+1)/BETA(J)
	RETURN
	END





